#ifndef MSP_DEMOSCENE_FADEOVERLAY_H_
#define MSP_DEMOSCENE_FADEOVERLAY_H_

#include <msp/gl/color.h>
#include <msp/gl/mesh.h>
#include <msp/gl/postprocessor.h>
#include <msp/gl/program.h>
#include <msp/gl/programdata.h>
#include "colorfade.h"
#include "sequencer.h"

namespace Msp {
namespace DemoScene {

class FadeOverlay: public Msp::GL::PostProcessor
{
public:
	class Fade: public ColorFadeAction
	{
	public:
		class Loader: public Msp::DataFile::DerivedObjectLoader<Fade, Action::Loader>
		{
		public:
			Loader(Fade &, Demo &);

		private:
			void overlay(const std::string &);
			void color(float, float, float, float);
		};

	private:
		FadeOverlay *overlay;

	public:
		Fade();
		Fade(FadeOverlay &, const Msp::GL::Color &);

		virtual void validate() const;

		virtual const Msp::GL::Color &get_color() const { return overlay->color; }
		virtual void set_color(const Msp::GL::Color &c) { overlay->set_color(c); }
	};

private:
	const Msp::GL::Mesh &mesh;
	const Msp::GL::Program &shprog;
	Msp::GL::ProgramData shdata;
	Msp::GL::Color color;

public:
	FadeOverlay(Msp::DataFile::Collection &);

	void set_color(const Msp::GL::Color &);

	virtual void render(Msp::GL::Renderer &, const Msp::GL::Texture2D &, const Msp::GL::Texture2D &);
};

} // namespace DemoScene
} // namespace Msp

#endif
