#ifndef MSP_DEMOSCENE_RESOURCES_H_
#define MSP_DEMOSCENE_RESOURCES_H_

#include <msp/datafile/directorysource.h>
#include <msp/datafile/packsource.h>
#include <msp/gl/font.h>
#include <msp/gl/resources.h>
#include <msp/gl/technique.h>

namespace Msp {
namespace DemoScene {

class Resources: public Msp::GL::Resources
{
private:
	Msp::DataFile::DirectorySource dir_source;
	Msp::DataFile::PackSource pack_source;

	const Msp::GL::Font *ui_font;
	const Msp::GL::Technique *ui_text_technique;

public:
	Resources(const std::string &);

	const Msp::GL::Font &get_ui_font() const;
	const Msp::GL::Technique &get_ui_text_technique() const;
	void set_ui_text_resources(const std::string &, const std::string &);
};

} // namespace DemoScene
} // namespace Msp

#endif
